//************************************************************************
// Datei: dualscreen.c
// Hauptprogramm
//
// Demoprogramm fr die Arbeit mit Dual Screens
//
// hk@holger-klabunde.de
// http://www.holger-klabunde.de
// 05.03.2006
// Compiler AVR-GCC 3.4.6
//************************************************************************
// Prozessor: See makefile
//************************************************************************

#include <avr/io.h>
#include <avr/interrupt.h>
//#include <sig-avr.h>
#include <stdlib.h>
#include <string.h>

#include "protos.h"
#include "dualscreen.h"
#include "serial.h"
#include "T6963.h"
#include "paul.h"
#include "demo.h"
#include "draw.h"

int main(void)
{
 int i;
 
 ser_init(); //Serielle Schnittstelle einstellen

 sei();              //enable interrupts

 DisplayOn();

 while(1) //endless loop
  {

   ClearTextScreen();
   ClearGScreen(G_BASE,G_END1); //Lsche beide Grafikschirme
   SetGBaseLine(0);             //zeige den unteren Schirm
   
   //zeichne Bitmap in den unteren Schirm
   LoadBitmap(demobmp, 0 , 0, demoWIDTH, demoHEIGHT);
   Delay1ms(1000);

   //zeichne drei Paulchen in den oberen Schirm
   LoadBitmap(paulbmp, 0 , LCD_HEIGHT, paulWIDTH, paulHEIGHT);
   LoadBitmap(paulbmp, paulWIDTH+10 , LCD_HEIGHT, paulWIDTH, paulHEIGHT);
   LoadBitmap(paulbmp, 2*(paulWIDTH+10) , LCD_HEIGHT, paulWIDTH, paulHEIGHT);

   //langsam in den oberen Schirm scrollen
   for(i=1; i<=LCD_HEIGHT; i++)
    {
     SetGBaseLine(i);
     Delay1ms(100);
    }

   Delay1ms(1000);

   //wieder in den unteren Schirm scrollen
   for(i=LCD_HEIGHT; i>=0; i--)
    {
     SetGBaseLine(i);
     Delay1ms(100);
    }

   Delay1ms(1000);

   //Jetzt ein paarmal schnell die beiden Schirme umschalten
   //und kurz anzeigen 
   for(i=0; i<5; i++)
    {
     SetGBaseLine(0); //zeige unteren Schirm
     Delay1ms(1000);

     SetGBaseLine(LCD_HEIGHT); //zeige oberen Schirm
     Delay1ms(1000);
    }

   Delay1ms(1000);

   ClearTextScreen();
   ClearGScreen(G_BASE,G_END1);
   SetGBaseLine(0);

//zeichne Paulchen in den unteren und den oberen Schirm
   LoadBitmap(paulbmp, 0, 0, paulWIDTH, paulHEIGHT);
   LoadBitmap(paulbmp, 0, LCD_HEIGHT, paulWIDTH, paulHEIGHT);

   //Text auf den Textschirm
   LCDText("Holger Klabunde",14,0);
   LCDText("T6963 Demo2",14,2);
   LCDText("Watch the text !",14,4);
   LCDText("It doesn't move",14,6);

   while(1)
    {
     SetGBaseLine(0);

     //langsam in den oberen Schirm scrollen
     for(i=1; i<=LCD_HEIGHT; i++)
      {
       SetGBaseLine(i);
       Delay1ms(100);
      }
   //Und gesehen ? Der Textbildschirm ist unabhngig vom Grafikschirm
    }

   
  } //Endlosschleife
}

//###################################################################################
//Nicht sonderlich genau !!
void Delay1ms(unsigned int time)
//###################################################################################
{
 unsigned int i;

 for(i=0; i<time; i++) Delay100us(10);
}

//###################################################################################
//Nicht sonderlich genau !!
//time<=255 !!
void Delay100us(unsigned char time)
//###################################################################################
{
 unsigned char k,l;

 for(k=0; k<time; k++)
  {
   for(l=0; l<40; l++)
    {
     //Ein CPU-Clock = 0.125us bei 8MHz
     NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP();  
     NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP(); NOP();  
    }
  }
}
